local ActiveMission=false
local MissionName="N/A"

local MissionType = ""
local IsRandomSpawnAnywhereInfo = {x=0,y=0,z=0}
local SafeHouseLocationIndex = 0
local MissionLocationIndex = 0


local servercheckspawns = false

--for mission timeouts
local MissionStartTime = 0
local MissionEndTime = 0
local MissionSpaceTime = 0
local MilliSecondsLeft = 0
local MissionNoTimeout = false
--used to see if we are in the time between missions, when one ends, and another starts
local blInSpaceTime = false 

--This is in minutes. How long to wait, when there are players online 
--for the server to find the host and trigger a new mission
local ExtraTimeToWaitToStartNextMission = 1

--Set this to true in case there are mutiple missions being started
--or duplicate NPC peds. 
--Experimental.
local blActiveMissionCheck=false

--The time between missions, is where the player who will trigger the next mission 
--can disconnect. Enable this value to true if you find the missions 
--stopping when this happens. Players or admins can use /mission Mission1 etc... though to start
--if this is turned off and it happens
--Experimental
local blHelpWithDisconnects=false


--ESX Support
local UseESX=false
if UseESX then
	TriggerEvent("esx:getSharedObject", function(obj)
	ESX = obj
	end)

	RegisterServerEvent("paytheplayer")
	AddEventHandler("paytheplayer",function(totalmoney)

	local _source = source
	local xPlayer = ESX.GetPlayerFromId(_source)
	xPlayer.addMoney(totalmoney)

	end)

end

--looks for setting within a mission, else looks at global setting
function getMissionConfigProperty(MissionName, PropName) 
	--print('MissionName'..MissionName)
	--print('PropName'..PropName)
	for i, v in pairs(Config.Missions[MissionName]) do
        if PropName == i then
			return v
			
        end
    end

	for i, v in pairs(Config) do
		if PropName == i then
			return v
			
        end
    end
	
			
end


RegisterServerEvent("sv:one")
AddEventHandler("sv:one", function(input,input2, time,rMissionLocationIndex,rMissionType,rIsRandomSpawnAnywhereInfo,rSafeHouseLocationIndex)
	--print("sv:one called to start new mission")
	if blActiveMissionCheck then 
		if(not ActiveMission) then 
			TriggerClientEvent('chatMessage', -1, "^1[MISSIONS]: ^2'".. input2 .."'^0 has been launched.")
			--TriggerClientEvent("mt:missiontext", -1, input, time)
			TriggerClientEvent('missionBlips', -1, input,rMissionLocationIndex,rMissionType,rIsRandomSpawnAnywhereInfo,rSafeHouseLocationIndex,true)
			TriggerClientEvent("SpawnPedBlips",-1, input)
			ActiveMission=true
			MissionName=input
			MissionType = rMissionType
			MissionLocationIndex = rMissionLocationIndex
			IsRandomSpawnAnywhereInfo = rIsRandomSpawnAnywhereInfo
			SafeHouseLocationIndex = rSafeHouseLocationIndex
			blInSpaceTime = false
			MissionStartTime = GetGameTimer() 
			MissionEndTime = MissionStartTime + getMissionConfigProperty(MissionName, "MissionLengthMinutes")*60*1000	
			MissionSpaceTime = getMissionConfigProperty(MissionName, "MissionSpaceTime")
			MilliSecondsLeft = MissionEndTime - MissionStartTime
			MissionNoTimeout = getMissionConfigProperty(MissionName, "MissionNoTimeout")
		end
		
	else 
		--print("rMissionType:"..rMissionType)
		--print("rMissionLocationIndex:"..rMissionLocationIndex)
		
		TriggerClientEvent('chatMessage', -1, "^1[MISSIONS]: ^2'".. input2 .."'^0 has been launched.")
		TriggerClientEvent("mt:missiontext", -1, input, time)
		--print("sv:one rSafeHouseLocationIndex"..rSafeHouseLocationIndex)
		--if(rSafeHouseLocationIndex) then
			--print("sv:one rSafeHouseLocationIndex found:"..rSafeHouseLocationIndex)
		--else
			--print("sv:one rSafeHouseLocationIndex not found:")
		--end
		TriggerClientEvent('missionBlips', -1, input,rMissionLocationIndex,rMissionType,rIsRandomSpawnAnywhereInfo,rSafeHouseLocationIndex,true) 
		TriggerClientEvent("SpawnPedBlips",-1, input)
		ActiveMission=true
		MissionName=input
		MissionType = rMissionType
		MissionLocationIndex = rMissionLocationIndex
		IsRandomSpawnAnywhereInfo = rIsRandomSpawnAnywhereInfo
		SafeHouseLocationIndex = rSafeHouseLocationIndex		
		blInSpaceTime = false
		MissionStartTime = GetGameTimer() 
		MissionEndTime = MissionStartTime + getMissionConfigProperty(MissionName, "MissionLengthMinutes")*60*1000
		MissionSpaceTime = getMissionConfigProperty(MissionName, "MissionSpaceTime")
		MilliSecondsLeft = MissionEndTime - MissionStartTime
		MissionNoTimeout = getMissionConfigProperty(MissionName, "MissionNoTimeout")
	end 
	
	
end)



--move this to bottom of file:
function doPlayersExist()
	local players = GetNumPlayerIndices() 
	local foundplayer = false
	for i = 0, players - 1 do
		if type(GetPlayerFromIndex(i))  ~=  "nil" then 
			foundplayer = true
		end		
	end
	--print("found player:"..tostring(foundplayer))
	return foundplayer

end

function getNextMission(MissionName) 
	local missioncount = 0
	local nextmission = ""
	
	if MissionName ~= "N/A" then 
		for i, v in pairs(Config.Missions) do
			missioncount = missioncount + 1
		end


		if Config.RandomMissions then
			math.randomseed(GetGameTimer())
			local randomNum = math.random(1,missioncount)
			nextmission = "Mission"..tostring(randomNum)
		else 
			local oldMissionNumber, _ = MissionName:gsub("%D+", "")
			if (tonumber(oldMissionNumber) + 1 > missioncount) then 
				nextmission = "Mission1"
			 else
				nextmission =  "Mission" .. tostring(math.floor((tonumber(oldMissionNumber))) + 1)
			
			end
		end 
		
		--dont let old random mission re-spawn
		if missioncount > 1 then 
			
			while( nextmission == MissionName )
			do
			   nextmission = "Mission"..tostring( math.random(1,missioncount))
			end
		else 
			nextmission = oldmission 
		end
		
	else 
		if Config.RandomMissions then
			nextmission = getNextMission("Mission1") --"Mission1"
		else
			nextmission = "Mission1"
		end
	end
	--print("nextmission:"..nextmission)
	return nextmission

end

Citizen.CreateThread(function()
	local starttick = GetGameTimer()
	local lastActiveMissionTime = starttick
	
	while true do
	
		--Citizen.Wait(60000) -- check minute
		Citizen.Wait(1000) 
		local tick = GetGameTimer()
		--MissionTime = -1, turn off timed mission checks
		if ActiveMission then 
			
			lastActiveMissionTime = tick
			
			MilliSecondsLeft = MissionEndTime - lastActiveMissionTime
		
			if tick >  MissionEndTime and (not MissionNoTimeout) then 
				--send client event to fail the current mission
				--TriggerClientEvent('DONE', -1, input,false,true,"Mission Timeout") 
				--print('MISSION TIMEOUT')
				TriggerClientEvent('mt:setmissionTimeout', -1,true)
			else 
				--send minutes left to clients
				--print("MissionStartTime:"..MissionStartTime)
				--local currmissionminutesleft = math.floor((MilliSecondsLeft)/60000) % 60
				--local currmissionsecondsleft = math.floor((MilliSecondsLeft)/1000) % 60
				--local extraseconds = currmissionsecondsleft - currmissionminutesleft*60
				local currmissionminutesleft = string.format("%02d", tostring(math.floor((MilliSecondsLeft)/60000) % 60))
				local currmissionsecondsleft = string.format("%02d", tostring(math.floor((MilliSecondsLeft)/1000) % 60))
				--print ("currmissionMilliSecondsLeft:"..MilliSecondsLeft)
				--print("currmissionminutesleft:"..currmissionminutesleft)
				--print("currmissionsecondsleft:"..currmissionsecondsleft)

				
				--TriggerClientEvent('mt:setmissiontimeleft', -1, MilliSecondsLeft) 
				
			end
			
		
		end 
		
		--check if we are not in space between missions or an active mission, 
		--and there are active players, and the extra time waited beyond the end of the last mission + spacetime has occured.
		--print("SERVER:Next time to send a mission:"..(((MissionEndTime + MissionSpaceTime) + ExtraTimeToWaitToStartNextMission*60*1000))- tick)
		if (not ActiveMission and not blInSpaceTime and ((tick) > (MissionEndTime + MissionSpaceTime) + ExtraTimeToWaitToStartNextMission*60*1000) and doPlayersExist()) then
				Wait(10000)
				if not ActiveMission then 
					print("Server Start Mission")
					TriggerClientEvent("mt:checkIfIAmHost", -1)
				end
		end
		
		
		-- if you want days then use this:
		-- local uptimeDay = math.floor((tick-starttick)/86400000)
		-- if you use day then change the hour to this:
		-- local uptimeHour = math.floor((tick-starttick)/3600000) % 24
		--local uptimeHour = math.floor((tick-starttick)/3600000)
		--if you want seconds then use this:
		--local uptimeMinute = math.floor((tick-starttick)/60000) % 60
		--local uptimeSecond = math.floor((tick-starttick)/1000) % 60
		--ExecuteCommand(string.format("sets Uptime \"%02dh %02dm\"", uptimeHour, uptimeMinute))
	end
end)

--setting decor values on NPCs on non-host clients do not seem to propogate
--like when on the host, so when non-host changes a value on an 
--NPC make sure everyone does it, most importantly the host as well
RegisterServerEvent("sv:rescuehostage")
AddEventHandler("sv:rescuehostage", function(hostageid,decorval)
	--print("sv:rescuehostage:"..hostageid)
    TriggerClientEvent('mt:rescuehostage', -1, hostageid,decorval)
	
end)

RegisterServerEvent("sv:two")
AddEventHandler("sv:two", function(message)
    TriggerClientEvent('chatMessage', -1, message)
	
end)

RegisterServerEvent("sv:message")
AddEventHandler("sv:message", function(message)
    TriggerClientEvent("mt:missiontext2", -1, message, 10000)
	
end)

RegisterServerEvent("sv:messagetosource")
AddEventHandler("sv:messagetosource", function(message)
    TriggerClientEvent("mt:missiontext2", source, message, 10000)
	
end)

--called by the/a client at mission end when completed
--for server to find the NetworkIsHost() to start the next mission
RegisterServerEvent("sv:getHostForNextMission")
AddEventHandler("sv:getHostForNextMission", function(input)
	print('sv:getHostForNextMission called')
   TriggerClientEvent("mt:checkIfIAmHost", -1)
	
end)

--capture replies from mt:checkIfIAmHost in order to find the host
--to spawn the NPCs and vehicles on, who will start the mission
RegisterServerEvent("sv:getClientWhoIsHostAndStartNextMission")
AddEventHandler("sv:getClientWhoIsHostAndStartNextMission", function(isHost,newMission)
  local nextmission = getNextMission(MissionName)
  if newMission then 
	nextmission = newMission
  end
  
  print("sv:getClientWhoIsHostAndStartNextMission called")
  if(isHost) then 
		print("found Host:"..source)
			print("next mission:"..nextmission)
		--triggerclient event to start next mission
		TriggerClientEvent("mt:startnextmission", source,nextmission)
   end
	
end)


--called by host, to have other clients readjust suspicious spawns
RegisterServerEvent("sv:checkspawns")
AddEventHandler("sv:checkspawns", function(checkspawns)
	servercheckspawns = checkspawns
    TriggerClientEvent("mt:checkspawns", -1, checkspawns)
	
	
end)

--called by connecting client, to see if they have to readjust suspicious spawns
--RegisterServerEvent("sv:getcheckspawns")
--AddEventHandler("sv:getcheckspawns", function()
   -- TriggerClientEvent("mt:checkspawns", source, servercheckspawns)
--end)
  
RegisterServerEvent("sv:done")
AddEventHandler("sv:done", function(input,isstop,isfail,reasontext)
	--make sure not multiple done messages
	if ActiveMission and MissionName~="N/A" then
			ActiveMission=false
			--MissionName="N/A" --< **Leave the mission as is, so the missions will rotate**
			servercheckspawns = false
			blInSpaceTime = false
			TriggerClientEvent('DONE', -1, input,isstop,isfail,reasontext) --GHK
	end
	
end)


RegisterServerEvent("sv:checkhostandremovepickups")
AddEventHandler("sv:checkhostandremovepickups", function(oldmission,nextmission,timetowait)
 local sourceplayer = source
	blInSpaceTime = true
	Citizen.Wait(timetowait)
	blInSpaceTime = false
	TriggerClientEvent('mt:removepickups', -1, oldmission) 
	--check if player index is still online
	local foundplayer = false
	local players = GetNumPlayerIndices()
	
	for i = 0, players - 1 do
	
		if tonumber(GetPlayerFromIndex(i))  ==  tonumber(sourceplayer) then 
			foundplayer = true
		end 
	
	end
	
	--can probaaly remove this code now:
	if not foundplayer and blHelpWithDisconnects then
	 --'host' player disconnected
		local newplayers = GetNumPlayerIndices() 
		local foundnewplayer = false
		local newindex = 0
		for i = 0, newplayers - 1 do
	
			if type(GetPlayerFromIndex(i))  ~=  "nil" then 
				foundnewplayer = true
				newindex = i
			end		
		
			if(foundnewplayer) then 
				--find another player to start the nextmission with
				--and 'hack' the client call for now, which is used for the first player on server 
				--blHelpWithDisconnects 
				--***DOUBLE CHECK THIS LOGIC ON CLIENT SIDE***
				--NEW MISSION...
				MilliSecondsLeft = getMissionConfigProperty(MissionName, "MissionLengthMinutes")*60*1000
				TriggerClientEvent('mt:setactive', GetPlayerFromIndex(newindex), 1,nextmission,1,false,MilliSecondsLeft)
			end 
		end

	end 
	
end)



--called when a player joins
--if mission is currently running on server (ActiveMission=true), and they are only player
	--enable mission for them and spawn peds, set mission blip, and NPC blips
--if mission is running on server (ActiveMission=true) and there are other players
	--enable mission for them, dont spawn peds, but set mission blip and NPC blips
--if mission is not running on server (ActiveMission=false), and they are the only player
   --set Mission to 'Mission1' and enable mission for them and spawn peds, set mission blips, and NPC blips
   
RegisterServerEvent("sv:checkmission")
AddEventHandler("sv:checkmission", function(blfirstplayer)

print('sv:checkmission')
local onlinePlayers = GetNumPlayerIndices()


	if onlinePlayers > 0  then
	
		if ActiveMission then
			print('mt:setactive activemission')
			TriggerClientEvent('mt:setactive', source, 1,MissionName,onlinePlayers,servercheckspawns,MilliSecondsLeft,ActiveMission,MissionType,MissionLocationIndex,IsRandomSpawnAnywhereInfo,SafeHouseLocationIndex)
			blInSpaceTime = false
	
		else 
			if onlinePlayers == 1 then 
				if MissionName == "N/A" then
					
				if Config.RandomMissions then
					MissionName = getNextMission("Mission1") --"Mission1"
				else
					MissionName = "Mission1"
				end
					
					
				end
				print('mt:setactive newmission')
				ActiveMission=true
				servercheckspawns = false
				blInSpaceTime = false
				--NEW MISSION...
				MissionStartTime = GetGameTimer() 
				MissionEndTime = MissionStartTime + getMissionConfigProperty(MissionName, "MissionLengthMinutes")*60*1000	
				MissionSpaceTime = getMissionConfigProperty(MissionName, "MissionSpaceTime")
				--both lines below are the same:
				--MilliSecondsLeft = MissionEndTime - MissionStartTime				
				MilliSecondsLeft = getMissionConfigProperty(MissionName, "MissionLengthMinutes")*60*1000
				MissionNoTimeout = getMissionConfigProperty(MissionName, "MissionNoTimeout")
				
				TriggerClientEvent('mt:setactive', source, 1,MissionName,onlinePlayers,servercheckspawns,MilliSecondsLeft,ActiveMission,MissionType,MissionLocationIndex,IsRandomSpawnAnywhereInfo,SafeHouseLocationIndex)
			end 
		end 	
	
	end 
end)


--all credit below to FAXES for his Vote-To-Kick resource: https://forum.fivem.net/t/release-vote-to-kick-vote-players-out-fax-vote2kick-1-0/191676
-----------------------------------
--- BASED ON: Vote to Kick, Made by FAXES ---
-----------------------------------

local voteCount = 0
local canStartVote = true
local voteActive = false
local tPlayer = nil

local svrSeconds = 0
local svrMinutes = 0

minVoteAmt = 1 -- Amount of 'yes' votes needed to cancel the mission

voteWaitTime = 1 -- Time in MINUTES that players must wait before using the voteCmd again

voteCmd = "votecancel" -- Command that starts the vote to cancel mission process

voteYesCmd = "voteyes" -- Command to vote yes on the kick.

voteNoCmd = "voteno" -- Command to vote no on the kick.

local newMission 


RegisterCommand(voteCmd, function(source, args, rawCommand)
    newMission = args[1]
	local foundmission = false
	    for i, v in pairs(Config.Missions) do
            if newMission == i then
				foundmission = true
			end
		end 

	if newMission and not foundmission then 
		 TriggerClientEvent("chatMessage", source, "^1[MISSIONS]:Please specify a valid mission like '/votecancel Mission1' or just use '/votecancel'. Use '/list' to view all available missions")
		  --TriggerClientEvent("chatMessage", source, "^1[MISSIONS]:Use '/list' to view all available missions")
		 newMission = nil
		
	elseif newMission and foundmission then
	
		if canStartVote == true then
			TriggerClientEvent("chatMessage", -1, "^*^1[MISSIONS]: VOTE TO CANCEL THE MISSION AND START THE NEW MISSION:")
			TriggerClientEvent("chatMessage", -1, "^*^1[MISSIONS]: ^2"..newMission..": '"..Config.Missions[newMission].MissionTitle.."'^7?")
			TriggerClientEvent("chatMessage", -1, "^*^1[MISSIONS]: ^7? Use /" .. voteYesCmd .. " & /" .. voteNoCmd)
			voteActive = true
			voteCount = 0
			canStartVote = false
			svrSeconds = 0
			svrMinutes = 0
		else
			TriggerClientEvent("chatMessage", source, "^1[MISSIONS]:Please wait before starting vote to cancel a mission.")
			 newMission = nil
		end	
	else  
		if canStartVote == true then
		  
			TriggerClientEvent("chatMessage", -1, "^*^1[MISSIONS]: VOTE TO CANCEL THE MISSION^7? Use /" .. voteYesCmd .. " & /" .. voteNoCmd)
			voteActive = true
			voteCount = 0
			canStartVote = false
			svrSeconds = 0
			svrMinutes = 0
		else
			TriggerClientEvent("chatMessage", source, "Please wait before starting vote to cancel a mission.")
		end
	end
	
end)

RegisterCommand(voteYesCmd, function(source, args, rawCommand)
    if voteActive then
        TriggerClientEvent("mrp:SubmitVote", source, "yes")
    else
        TriggerClientEvent("chatMessage", source, "There is no active vote-to-cancel.")
    end
end)

RegisterCommand(voteNoCmd, function(source, args, rawCommand)
    if voteActive then
        TriggerClientEvent("mrp:SubmitVote", source, "no")
    else
        TriggerClientEvent("chatMessage", source, "There is no active vote-to-cancel.")
    end
end)


Citizen.CreateThread(function()
	while true do
		Citizen.Wait(1000)
		svrSeconds = svrSeconds + 1
		if svrSeconds == 60 then
			svrSeconds = 0
            svrMinutes = svrMinutes + 1
        end
        if svrMinutes == voteWaitTime then
            canStartVote = true
            svrSeconds = 0
            svrMinutes = 0
        end
	end
end)

RegisterServerEvent("mrp:SendVote")
AddEventHandler("mrp:SendVote", function()
    voteCount = voteCount + 1
end)

Citizen.CreateThread(function()
	while true do
        Citizen.Wait(1000)
        if voteActive then
            if voteCount == minVoteAmt then
				if ActiveMission and MissionName~="N/A" then
					ActiveMission=false
					--MissionName="N/A" --< **Leave the mission as is, so the missions will rotate**
					servercheckspawns = false
					blInSpaceTime = false
					TriggerClientEvent('DONE', -1, MissionName,false,true,"cancel") --GHK
				end   
                voteActive = false
                voteCount = 0
                TriggerClientEvent("mrp:ResetVotes", -1)
				--start next mission after 10 seconds:
				Wait(10000)
				if not ActiveMission then 
					print("Server Start Mission After Vote")
					if newMission then 
						TriggerClientEvent("mt:checkIfIAmHost", -1,newMission)
					else 
						TriggerClientEvent("mt:checkIfIAmHost", -1)
					end
				end				
            end
        end
	end
end)


